import es
import gamethread
import popuplib
import usermsg
import msglib


auto_enable = 1 # If the menu should be enabled on join
updaterate = 1 # How often the menu should update (in seconds)
style = 2 # The style the spectators are shown ( 1 = hud hint, 2 = popup, 3 = toptext [You can set the updaterate pretty high with toptext])
max_length = 8 # The maximum length a name may have (Will be shortened otherwise: Absolute123 would be shortened to Absolu..)
advert_time = 120 # The time between the adverts (in seconds)
ignore_list = ["STEAM_0:0:44884","STEAM:0:123456789"] # these players will not been shown as spectating
# Following are the colors of the toptext (if its used)
R = 175
G = 175
B = 175

info = es.AddonInfo()
info.author      = "AbSoLuTe"
info.name        = "Tell Spectator names"
info.basename    = "tellspec"
info.version     = "1.3"
info.url         = "http://addons.eventscripts.com/addons/view/%s"%info.basename
info.description = "Shows who is spectating whom" 

es.ServerVar(info.basename, info.version, info.description + " made by " + info.author).makepublic()

enabled = []
advert = 0
update_in_sec = 1 / updaterate
advert_time = advert_time * update_in_sec

def load():
    es.regsaycmd('!disable',"%s/disabled"%info.basename,"Disables or Enables the Menu")
    
def unload():
    es.unregsaycmd('!disable')
    
def disabled():
    uid = int(es.getcmduserid())
    if uid in enabled:
        es.tell(uid,"#multi","#greenYou will no longer see the spectator menu")
        enabled.remove(uid)
    else:
        es.tell(uid,"#multi","#greenYou see the spectator menu again")
        enabled.append(uid)

def player_connect(event_var):
    uid = int(event_var['userid'])
    if auto_enable:
        enabled.append(uid)
def player_disconnect(event_var):
    uid = int(event_var['userid'])
    if uid in enabled:
        enabled.remove(uid)

def checkloop():
    global advert
    if not advert:
        advert = 0
    advert = advert + 1
    if advert >= advert_time:
        advert = 0
        es.msg("#multi","#greenType #lightgreen'!disable'#green to toggle the spectator menu. Written by #defaultAbSoLuTe#green.")
    ulist = es.getUseridList()
    for uid in es.getUseridList():
        if not es.getplayerprop(uid, "CCSPlayer.baseclass.pl.deadflag"):
            if uid in ulist:
                ulist.remove(uid)
            telllist = []
            spectators = ""
            temp = 0
            comparehandle = es.getplayerhandle(uid)
            for specs in ulist:
                if es.getplayersteamid(specs) in ignore_list:
                    if specs in ulist:
                        ulist.remove(specs)
                    continue
                if int(es.getplayerprop(specs, "CCSPlayer.baseclass.m_iObserverMode")) in (1,3,4):
                    if es.getplayerprop(specs, 'CBasePlayer.m_hObserverTarget') == comparehandle:
                        
                        if specs in enabled:
                            telllist.append(specs)
                        if specs in ulist:
                            ulist.remove(specs)
                        if len(es.getplayername(specs)) > max_length:
                            realname = es.getplayername(specs)[:max_length-2] + ".."
                        else:
                            realname = es.getplayername(specs)
                        if style == 3:
                            spectators = spectators + ", " + realname.replace("\n","\\n")
                        elif style == 2:
                            spectators = spectators + "\n  " + realname.replace("\n","\\n")
                        elif style == 1:
                            temp = temp + 1
                            if temp == 4:
                                temp = 0
                                spectators = spectators + "\n" + realname.replace("\n","\\n")
                            else:
                                spectators = spectators + ", " + realname.replace("\n","\\n")
                else:
                    ulist.remove(specs)
            if spectators:
                if uid in enabled:
                    if style == 3:
                        msglib.VguiDialog('Your Spectators: ' + spectators[1:],'',5,"%s %s %s 255" % (R,B,G),updaterate).send(uid)
                    elif style == 2:
                        popuplib.quicksend(updaterate, uid, "Your Spectators:" + spectators + "\nType !disable to disable")
                    elif style == 1:
                        usermsg.hudhint(uid,"Your Spectators:\n" + spectators[1:])
                if telllist:
                    for uid2 in telllist:
                        if style == 3:
                            msglib.VguiDialog('Spectating %s: ' % es.getplayername(uid) + spectators[1:],'',5,"%s %s %s 255" % (R,B,G),updaterate).send(uid2)
                        elif style == 2:
                            popuplib.quicksend(updaterate, uid2, 'Spectating %s: ' % es.getplayername(uid) + spectators + "\nType !disable to disable")
                        elif style == 1:
                            usermsg.hudhint(uid2,'Spectating %s:\n ' % es.getplayername(uid) + spectators[1:])
          
    gamethread.delayed(updaterate,checkloop)
   
checkloop()